unit Edit.Form;

interface

uses
  System.Classes,
  Data.DB,
  Vcl.Forms, Vcl.Controls, Vcl.StdCtrls, Vcl.Mask, Vcl.DBCtrls,
  Main.DM;

type
  TEditForm = class(TForm)
    Button1: TButton;
    dsData: TDataSource;
    DBText1: TDBText;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
  private
    FDataModule: TMainDM;
    FOnReferenceName: TReferenceNameEvent;
  protected
    procedure AdjustReference(var Value: string; AComponent: TComponent);
    procedure MyReferenceName(Reader: TReader; var Name: string);
    procedure ReadState(Reader: TReader); override;
  public
    constructor Create(AOwner: TComponent); override;
    property DataModule: TMainDM read FDataModule;
  end;

var
  EditForm: TEditForm;

implementation

uses
  System.SysUtils;

{$R *.dfm}

{.$DEFINE KeepUniqueDataModuleNames}

procedure ResetComponentName(AComponent: TComponent);
begin
  AComponent.Name := AComponent.ClassName.Substring(1);
end;

constructor TEditForm.Create(AOwner: TComponent);
begin
  FDataModule := TMainDM.Create(Self);
  {$IFNDEF KeepUniqueDataModuleNames}
  ResetComponentName(FDataModule);
  {$ENDIF}
  inherited;
end;

procedure TEditForm.AdjustReference(var Value: string; AComponent: TComponent);
var
  fromName: string;
  toName: string;
begin
  fromName := AComponent.ClassName.Substring(1); // Remove T
  toName := AComponent.Name;
  if Value = fromName then
    Value := toName
  else if Value.StartsWith(fromName + '.') then
    Value := Value.Remove(0, fromName.Length).Insert(0, toName);
end;

procedure TEditForm.MyReferenceName(Reader: TReader; var Name: string);
begin
  {$IFDEF KeepUniqueDataModuleNames}
  AdjustReference(Name, DataModule);
  {$ENDIF}
  if Assigned(FOnReferenceName) then
    FOnReferenceName(Reader, Name);
end;

procedure TEditForm.ReadState(Reader: TReader);
begin
  FOnReferenceName := Reader.OnReferenceName;
  try
    Reader.OnReferenceName := MyReferenceName;
    inherited;
  finally
    Reader.OnReferenceName := FOnReferenceName;
  end;
end;

end.

