unit Main.DM;

interface

uses
  System.SysUtils, System.Classes, System.Actions,
  Data.DB,
  Vcl.ActnList,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf,
  FireDAC.DApt.Intf, FireDAC.Stan.Async, FireDAC.DApt, FireDAC.Comp.DataSet, FireDAC.Comp.Client;

type
  TMainDM = class(TDataModule)
    ActionList1: TActionList;
    Action1: TAction;
    tblData: TFDQuery;
    tblDataEMP_NO: TSmallintField;
    tblDataFIRST_NAME: TStringField;
    tblDataLAST_NAME: TStringField;
    tblDataPHONE_EXT: TStringField;
    tblDataHIRE_DATE: TSQLTimeStampField;
    tblDataDEPT_NO: TStringField;
    tblDataJOB_CODE: TStringField;
    tblDataJOB_GRADE: TSmallintField;
    tblDataJOB_COUNTRY: TStringField;
    tblDataSALARY: TFMTBCDField;
    tblDataFULL_NAME: TStringField;
    procedure DataModuleCreate(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure Action1Update(Sender: TObject);
  private
    FInstanceNr: Integer;
  public
    procedure SyncRecord(Source: TMainDM);
    property InstanceNr: Integer read FInstanceNr;
  end;

var
  MainDM: TMainDM;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses
  DBConnect.DM;

{$R *.dfm}

var
  InstanceCount: Integer = 0;

procedure TMainDM.DataModuleCreate(Sender: TObject);
begin
  Inc(InstanceCount);
  FInstanceNr := InstanceCount;
  tblData.Active := True;
end;

procedure TMainDM.Action1Execute(Sender: TObject);
begin
  tblData.Post;
end;

procedure TMainDM.Action1Update(Sender: TObject);
begin
  Action1.Caption := 'Save ' + tblDataEMP_NO.AsString;
end;

procedure TMainDM.SyncRecord(Source: TMainDM);
begin
  if Source = Self then Exit;

  tblData.Locate(tblDataEMP_NO.FieldName, Source.tblDataEMP_NO.Value);
end;

end.

